(function() {
    var rapParams = [
        'gclid',
        'wbraid',
        'fbclid'
    ];

    function getUrlParams() {
        try {
            var urlParams = new URLSearchParams(window.location.search);
            var params = {};
            for (var pair of urlParams.entries()) {
                params[pair[0]] = pair[1];
            }
            return params;
        } catch (error) {
            return false;
        }
    }

    function isRapParamPresent() {
        try {
            var params = getUrlParams();
            // If one or more rap params are present, return true and store in session storage a flag 1, otherwise 0
            var isRapParamPresent = rapParams.some(function(param) {
                return params[param];
            });
            sessionStorage.setItem('is_rap_present', isRapParamPresent ? '1' : '0');
            return isRapParamPresent;
        } catch (error) {
            return false;
        }
    }

    // Expose methods if needed
    window.RAP = {
        getUrlParams: getUrlParams,
        isRapParamPresent: isRapParamPresent
    };
})();
